import QtQuick
import QtQuick.Controls
import QtQuick.Layouts

Window {
    id: window
    visible: true
    title: "Hello World"
    visibility: Window.Maximized
    flags: Qt.FramelessWindowHint

    property var wallpaperIndex: 0
    property var isLoading: false
    property var bridge
    property var currentTime: initialTime

    Connections {
        target: bridge

        function onIsLoading(loading) {
            isLoading = loading
        }
    }

    Image {
        id: wallpaperImage
        height: window.height
        width: window.width
        visible: true
        source: wallpapers[wallpaperIndex]
        fillMode: Image.PreserveAspectCrop
    } 

    Popup {
        visible: isLoading
        x: Math.round((parent.width - width) / 2)
        y: Math.round((parent.height - height) / 2)
        width: 100
        height: 100

        background: BusyIndicator {
            running: isLoading
            width: 100
            height: 100
        }
    }

    Timer {
        interval: 30  * 1000
        running: !isLoading
        repeat: true
        onTriggered: wallpaperIndex = (wallpaperIndex + 1) % wallpapers.length
    }

    Timer {
        interval: 5 * 1000
        running: true
        repeat: true
        onTriggered: currentTime = bridge.currentTime()
    }

    Label {
        text: currentTime
        anchors.right: wallpaperImage.right
        anchors.top: wallpaperImage.top
        anchors.topMargin: 20
        anchors.rightMargin: 20
        font.pixelSize: 50
    }
}